<?
/*
* Plugin Name: Crew Manager
* File weight-shortcode.php
* File Version 1.1.0 Beta
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
* Inserts [weight] shortcode to allow logged in skipper to view
* a regatta report for weight and sailor classification status. 
* Includes links to user profiles for editing if desired.
* 6/18/2018 Originated
*/

function content_weight($atts, $content_weight = null){
$current_user = wp_get_current_user(); // gets user logged in
$cur_yr = date('Y'); // gets curent year for query

if (isset($_SESSION['regatta'])) $post_id = $_SESSION['regatta'];
if(isset($_POST['regatta'])){
// save regatta selected for page submission refresh 
$_SESSION['regatta'] = $_POST['regatta'];
$post_id = $_SESSION['regatta']; // get the selected crew from dropdown
}

     $table ="<form action=\"\" method=\"post\">";
     $table .= "<table>";

     $table .= "<td align = \"center\" width=\"25%\">".get_regatta_dropdown($post_id)."</td><td><input type=\"submit\" name=\"RegattaSubmit\" value=\"<=Select Regatta & Click Here to Update\"></td>";
    $table .="</table>";
    $table .="</form>";
if(isset($_POST['crew'])){
// save crew selected for page submission refresh 
$_SESSION['regatta'] = $_POST['regatta'];
$post_id = $_SESSION['regatta']; // get the selected regatta from dropdown
}
// above is end of RegattaSubmit


    if($current_user->ID!=0){ // display table only if logged in
// Get the data from the ai1ec_events table in the Wordpress database.
     global $crew_manager_options; // allows global [time_offset] and [availability_hide] in query
$tz = $crew_manager_options['time_zone'];
date_default_timezone_set($tz); //Corrects for local
     $event_date=date("D, M jS", $row['Start']);

     $Event_URL='<a href="'.get_permalink( $post_id ).'">'.get_the_title( $post_id ).'</a>';

global $wpdb;
    $table_ai1ec_events  = $wpdb->prefix."ai1ec_events";
    $table_crewmgr_assigned  = $wpdb->prefix."crewmgr_assigned";
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
    $table_users  = $wpdb->prefix."users";
    $table_usermeta  = $wpdb->prefix."usermeta";
    $table_posts  = $wpdb->prefix."posts";
$crewquery = $wpdb->get_results("SELECT `u`.ID 'ID', cmp.position 'Position', cmp.position_id 'PosID', `cma`.available 'Available', cma.id 'AvailID', e.post_id 'PostID'  FROM `$table_ai1ec_events` `e`, `$table_crewmgr_assigned` `cma`, $table_crewmgr_position cmp, `$table_users` `u`, `$table_usermeta` `m`    
WHERE `e`.post_id = '$post_id' AND `cma`.ai1ec_post_id = '$post_id'
AND cma.position_id = cmp.position_id
AND `u`.ID = `cma`.user_ID
AND `cma`.available < 3
AND `u`.ID = `m`.user_id
GROUP BY `u`.ID
ORDER BY `cma`.available, `u`.display_name
", ARRAY_A);

    $table .="<table width=\"100%\"  border=\"1\" cellspacing=\"0\" cellpadding=\"0\">";
    $table .= "<tr><td colspan=\"6\"><center><b><h2>$Event_URL</h2></b></center></td></tr>";
    $table .= "<td colspan=\"6\"><b>Crew Color Codes:</b> Green crew is confirmed. Yellow crew need to verify with Skipper.  Red does not crew for event.  White crew position assignment not made yet and need to verify with Skipper.</td>";
    $table .= "<tr><td><b>Name</b></td><td align = \"center\"><b>Weight (lbs)</b></td><td><b>Position</b></td><td><b>Sailor ID</b></td><td><b>Sailor Classification</b></td><td><b>US Sailing #</b></td></tr>";

	$weight_total=$counter=0; // initialze summation
		foreach( $crewquery as $row ){
	     $bgcolor="#ffffff"; // white  
	     if($row['Available']=="3" || $row['Position']=="Stay Ashore") $bgcolor="#ffccff"; // pink  
    	 if($row['Available']=="1" && $row['Position']=="Standby Crew") $bgcolor="#ffff99"; // yellow 
	     if($row['Available']=="2") $bgcolor="#ffff99"; // yellow
	     if($row['Available']=="1" && ($row['Position']!="Not Assigned" && $row['Position']!="Standby Crew")) $bgcolor="#C2FFC2"; // green
	     if(($row['Available']=="1" || $row['Available']=="2") && $row['Position']=="Not Assigned") $bgcolor="#ffffff"; // white
	     if($row['Position']=="Stay Ashore") $bgcolor="#ffccff"; // pink  
			$user_id = $row['ID'];
			$user_info = get_userdata( $user_id );
			$user_meta = get_user_meta( $user_id );
$classification = "";
			IF ($user_info->isaf_classification == 3) $classification = "Group 3 (Professional)";
			IF ($user_info->isaf_classification == 1) $classification = "Group 1 (Amateur)";
			$weight = $user_info->weight;
			$pos=get_position($user_id, $post_id);

			$weight_total = $weight + $weight_total;
	if ($crew_manager_options['include_helm'] == 1 && $crew_manager_options['weight_limit'] !== 0 && $pos == "Helm" ) $weight_total = $weight_total - $weight; // subtract helm weight

 $profile_link="<a class='link' href=\"".admin_url( 'user-edit.php?user_id=' . $user_id, 'http' )."\" target=\"_blank\">".$user_info->first_name." ".$user_info->last_name . "</a>"; // display with link to edit user profile

			$counter++;
     $table .= "<tr><td bgcolor=$bgcolor>". $counter . ". " . $profile_link . "</td><td bgcolor=$bgcolor align = \"center\">". $user_info->weight . "</td><td bgcolor=$bgcolor>". $pos . "</td><td bgcolor=$bgcolor>". $user_info->isaf_number . "</td><td bgcolor=$bgcolor>". $classification . "</td><td bgcolor=$bgcolor>". $user_info->ussailing . "</td></tr>";
		}
	$allowed_weight = $crew_manager_options['weight_limit'];
	if ($crew_manager_options['include_helm'] == 1 ) $helmsman_in_or_out = "  Helmsman weight is excluded from total.";

	$delta = $weight_total - $allowed_weight;
	$message = "<= " . -$delta . " lbs under " . $allowed_weight . " lb limit. " . $helmsman_in_or_out;
	if ($delta > 0 ) $message = "<= " . $delta . " lbs over " . $allowed_weight . " lb limit. " . $helmsman_in_or_out;
	if ($crew_manager_options['weight_limit'] == 0 ) $message = "There is no weight limit";

     $table .= "<tr><td align = \"right\" >Total: </td><td align = \"center\" >". $weight_total . "</td><td colspan=\"4\">" . $message . "</td></tr>";
    $table .="</table>";
     global $crew_manager_options; 
    if($current_user->ID == (int)$crew_manager_options['skipper'] || (int)$current_user->ID == $crew_manager_options['skipper_admin'] || current_user_can('administrator')){ // display table only if logged in as admin

        return $table;
} // endif logged in check from way above

    }else{
    $table ="<h3>Only the Skipper can see this page</h3>";
    $table .="<h4>Skipper - Please <a href=\"".wp_login_url( get_permalink() )."\" title=\"Login\">Login</a> to view a crew weight and sailor classification report.</h4>";
        return $table;
    }
}

add_shortcode('weight', 'content_weight');
// end of [weight] shortcode ***************************
